diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 7348afccc..6706e3f2a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -681,139 +685,139 @@ public class RenderGlobal
                 GL11.glEnable(GL11.GL_ALPHA_TEST);
                 GL11.glEnable(GL11.GL_FOG);
                 count += renderChunks(from, to, renderPass, partialTick);
-            } while (to < sortedChunkRenderers.length);
+            } while (to < this.sortedChunkRenderers.length);
         } else {
-            count += renderChunks(0, sortedChunkRenderers.length, renderPass, partialTick);
+            count += renderChunks(0, this.sortedChunkRenderers.length, renderPass, partialTick);
         }
         return count;
     }
 
     private void checkQueryResults(int from, int to) {
         for (int i = from; i < to; i++) {
-            if (!sortedChunkRenderers[i].occlusionQuerying) {
+            if (!this.sortedChunkRenderers[i].occlusionQuerying) {
                 continue;
             }
-            resultBuffer.clear();
-            ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, resultBuffer);
-            if (resultBuffer.get(0) != 0) {
-                sortedChunkRenderers[i].occlusionQuerying = false;
-                resultBuffer.clear();
-                ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, resultBuffer);
-                sortedChunkRenderers[i].occlusionVisible = resultBuffer.get(0) != 0;
+            this.resultBuffer.clear();
+            ARBOcclusionQuery.glGetQueryObjectuivARB(this.sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, this.resultBuffer);
+            if (this.resultBuffer.get(0) != 0) {
+                this.sortedChunkRenderers[i].occlusionQuerying = false;
+                this.resultBuffer.clear();
+                ARBOcclusionQuery.glGetQueryObjectuivARB(this.sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, this.resultBuffer);
+                this.sortedChunkRenderers[i].occlusionVisible = this.resultBuffer.get(0) != 0;
             }
         }
 
     }
 
     private int renderChunks(int from, int to, int renderPass, double partialTick) {
-        renderChunks.clear();
+        this.renderChunks.clear();
         int count = 0;
 
         for (int i = from; i < to; i++) {
             if (renderPass == 0) {
-                totalChunks++;
-                if (sortedChunkRenderers[i].empty[renderPass]) {
-                    emptyChunks++;
-                } else if (!sortedChunkRenderers[i].visible) {
-                    offscreenChunks++;
-                } else if (occlusionCheck && !sortedChunkRenderers[i].occlusionVisible) {
-                    occludedChunks++;
+                this.totalChunks++;
+                if (this.sortedChunkRenderers[i].empty[renderPass]) {
+                    this.emptyChunks++;
+                } else if (!this.sortedChunkRenderers[i].visible) {
+                    this.offscreenChunks++;
+                } else if (this.occlusionCheck && !this.sortedChunkRenderers[i].occlusionVisible) {
+                    this.occludedChunks++;
                 } else {
-                    renderedChunks++;
+                    this.renderedChunks++;
                 }
             }
 
-            if (sortedChunkRenderers[i].empty[renderPass] || !sortedChunkRenderers[i].visible || occlusionCheck && !sortedChunkRenderers[i].occlusionVisible) {
+            if (this.sortedChunkRenderers[i].empty[renderPass] || !this.sortedChunkRenderers[i].visible || this.occlusionCheck && !this.sortedChunkRenderers[i].occlusionVisible) {
                 continue;
             }
-            int list = sortedChunkRenderers[i].getList(renderPass);
+            int list = this.sortedChunkRenderers[i].getList(renderPass);
             if (list >= 0) {
-                renderChunks.add(sortedChunkRenderers[i]);
+                this.renderChunks.add(this.sortedChunkRenderers[i]);
                 count++;
             }
         }
 
-        double xOff = mc.activeCamera.getX((float) partialTick);
-        double yOff = mc.activeCamera.getY((float) partialTick);
-        double zOff = mc.activeCamera.getZ((float) partialTick);
+        double xOff = this.mc.activeCamera.getX((float) partialTick);
+        double yOff = this.mc.activeCamera.getY((float) partialTick);
+        double zOff = this.mc.activeCamera.getZ((float) partialTick);
         int lists = 0;
-        for (DisplayList displayList : renderLists) {
+        for (DisplayList displayList : this.renderLists) {
             displayList.clear();
         }
 
-        for (ChunkRenderer renderer : renderChunks) {
+        for (ChunkRenderer renderer : this.renderChunks) {
             int list = -1;
             for (int i = 0; i < lists; i++) {
-                if (renderLists[i].isSetToPos(renderer.xRender, renderer.yRender, renderer.zRender)) {
+                if (this.renderLists[i].isSetToPos(renderer.xRender, renderer.yRender, renderer.zRender)) {
                     list = i;
                 }
             }
 
             if (list < 0) {
                 list = lists++;
-                renderLists[list].setToPos(renderer.xRender, renderer.yRender, renderer.zRender, xOff, yOff, zOff);
+                this.renderLists[list].setToPos(renderer.xRender, renderer.yRender, renderer.zRender, xOff, yOff, zOff);
             }
-            renderLists[list].addCallToList(renderer.getList(renderPass));
+            this.renderLists[list].addCallToList(renderer.getList(renderPass));
         }
 
-        if (!mc.gameSettings.fog.value) {
+        if (!this.mc.gameSettings.fog.value) {
             GL11.glDisable(GL11.GL_FOG);
         }
         renderSameAsLast(renderPass, partialTick);
-        if (!mc.gameSettings.fog.value) {
+        if (!this.mc.gameSettings.fog.value) {
             GL11.glEnable(GL11.GL_FOG);
         }
         return count;
     }
 
     public void renderSameAsLast(int renderPass, double partialTick) {
-        for (DisplayList displayList : renderLists) {
+        for (DisplayList displayList : this.renderLists) {
             displayList.call();
         }
 
     }
 
     public void tick() {
-        float windDirection = world.worldType.getWindManager().getWindDirection(world, 0.0f, 500f, 0.0f);
-        float windIntensity = world.worldType.getWindManager().getWindIntensity(world, 0.0f, 500f, 0.0f);
+        float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, 0.0f, 500f, 0.0f);
+        float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, 0.0f, 500f, 0.0f);
 
         float dx = -(float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
         float dz = -(float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
 
-        cloudVelocityX += dx;
-        cloudVelocityZ += dz;
+        this.cloudVelocityX += dx;
+        this.cloudVelocityZ += dz;
 
         float maxVel = 1.5f;
-        if (cloudVelocityX > maxVel) cloudVelocityX = maxVel;
-        if (cloudVelocityX < -maxVel) cloudVelocityX = -maxVel;
-        if (cloudVelocityZ > maxVel) cloudVelocityZ = maxVel;
-        if (cloudVelocityZ < -maxVel) cloudVelocityZ = -maxVel;
+        if (this.cloudVelocityX > maxVel) this.cloudVelocityX = maxVel;
+        if (this.cloudVelocityX < -maxVel) this.cloudVelocityX = -maxVel;
+        if (this.cloudVelocityZ > maxVel) this.cloudVelocityZ = maxVel;
+        if (this.cloudVelocityZ < -maxVel) this.cloudVelocityZ = -maxVel;
 
-        lastCloudOffsetX = cloudOffsetX;
-        lastCloudOffsetZ = cloudOffsetZ;
-        cloudOffsetX += cloudVelocityX;
-        cloudOffsetZ += cloudVelocityZ;
+        this.lastCloudOffsetX = this.cloudOffsetX;
+        this.lastCloudOffsetZ = this.cloudOffsetZ;
+        this.cloudOffsetX += this.cloudVelocityX;
+        this.cloudOffsetZ += this.cloudVelocityZ;
 
-        ticks++;
+        this.ticks++;
     }
 
     public void renderSky(float partialTick) {
-        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
-        if (!worldTypeFX.hasSky() || mc.currentScreen instanceof ScreenModelViewer) {
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType());
+        if (!worldTypeFX.hasSky() || this.mc.currentScreen instanceof ScreenModelViewer) {
             return;
         }
-        float celestialAngle = world.getCelestialAngle(partialTick);
+        float celestialAngle = this.world.getCelestialAngle(partialTick);
         GL11.glDisable(GL_TEXTURE_2D);
-        Vec3 skyColor = world.getSkyColor(mc.activeCamera, partialTick);
-        float r = (float) skyColor.x;
-        float g = (float) skyColor.y;
-        float b = (float) skyColor.z;
+        Vector3fc skyColor = this.world.getSkyColor(this.mc.activeCamera, partialTick);
+        float r = skyColor.x();
+        float g = skyColor.y();
+        float b = skyColor.z();
         GL11.glColor3f(r, g, b);
         Tessellator t = Tessellator.instance;
         GL11.glDepthMask(false);
         GL11.glEnable(GL_FOG);
         GL11.glColor3f(r, g, b);
-        GL11.glCallList(skyList);
+        GL11.glCallList(this.skyList);
         GL11.glDisable(GL_FOG);
         GL11.glDisable(GL_ALPHA_TEST);
         GL11.glEnable(GL_BLEND);
@@ -849,7 +853,7 @@ public class RenderGlobal
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE);
         GL11.glPushMatrix();
-        float sunAlpha = 1.0F - (world.getCurrentWeather() != null && world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        float sunAlpha = 1.0F - (this.world.getCurrentWeather() != null && this.world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (this.world.weatherManager.getWeatherIntensity() * this.world.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
 
         float x = 0.0F;
         float y = 0.0F;
@@ -861,7 +865,7 @@ public class RenderGlobal
 
         // Render sun
         float size = 30F;
-        textureManager.loadTexture("/assets/minecraft/textures/terrain/sun.png").bind();
+        this.textureManager.loadTexture("/assets/minecraft/textures/terrain/sun.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, 100D, -size, 0.0D, 0.0D);
@@ -871,10 +875,10 @@ public class RenderGlobal
         t.draw();
 
         // Render Rainbow
-        if (world.rainbowTicks > 0 || (!Double.isNaN(rainbowBrightness) && rainbowBrightness > 0)) {
+        if (this.world.rainbowTicks > 0 || (!Double.isNaN(this.rainbowBrightness) && this.rainbowBrightness > 0)) {
             // Calculates the progress through the rainbow, with peak brightness halfway through its lifespawn
-            final float halfRainbowLength = (world.startingRainbowTicks / 2f);
-            float rainbowTimeScalar = 1 - (Math.abs((world.rainbowTicks + partialTick) - halfRainbowLength) / halfRainbowLength);
+            final float halfRainbowLength = (this.world.startingRainbowTicks / 2f);
+            float rainbowTimeScalar = 1 - (Math.abs((this.world.rainbowTicks + partialTick) - halfRainbowLength) / halfRainbowLength);
 
             // Calculates the potential max rainbow brightness based on time of day
             float timeScalar;
@@ -894,41 +898,39 @@ public class RenderGlobal
             timeScalar *= cutoff;
             timeScalar *= rainbowTimeScalar;
 
-            Weather[] blocked = world.getBlockBiome(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z)).blockedWeathers;
+            Weather[] blocked = this.world.getBlockBiome(new TilePos(this.mc.thePlayer)).blockedWeathers;
             boolean isWeatherBlocked = false;
             for (Weather w : blocked) {
-                if (w.equals(world.weatherManager.getLastWeather())) {
+                if (w.equals(this.world.weatherManager.getLastWeather())) {
                     isWeatherBlocked = true;
                     break;
                 }
             }
 
+            double targetRainbowBrightness;
             if (isWeatherBlocked) {
                 targetRainbowBrightness = 0;
             } else {
                 targetRainbowBrightness = timeScalar;
             }
 
-            if (Double.isNaN(rainbowBrightness)) {
-                rainbowBrightness = targetRainbowBrightness;
+            if (Double.isNaN(this.rainbowBrightness)) {
+                this.rainbowBrightness = targetRainbowBrightness;
             }
 
-            double totalDelta = targetRainbowBrightness - rainbowBrightness;
-            rainbowBrightnessDelta = totalDelta / 100;
-            rainbowBrightness += rainbowBrightnessDelta * partialTick;
+            double totalDelta = targetRainbowBrightness - this.rainbowBrightness;
+            double rainbowBrightnessDelta = totalDelta / 100;
+            this.rainbowBrightness += rainbowBrightnessDelta * partialTick;
 
             // Draws and colors ring textures to make the rainbow
-            textureManager.loadTexture("/assets/minecraft/textures/terrain/rainbow.png").bind();
+            this.textureManager.loadTexture("/assets/minecraft/textures/terrain/rainbow.png").bind();
             t.startDrawingQuads();
             final int iterations = 10;
             for (int i = 0; i < iterations; i++) {
                 size = 200F - i * 4;
-                int color = java.awt.Color.HSBtoRGB(i / (float) iterations, 1, (float) (0.3f * rainbowBrightness));
-                float colR = ((color >> 16) & 0xFF) / 255f;
-                float colG = ((color >> 8) & 0xFF) / 255f;
-                float colB = ((color >> 0) & 0xFF) / 255f;
-                float rainbowAlpha = (float) ((0.35f - (0.15f * Math.abs(i - iterations / 2) / (iterations / 2f))) * rainbowBrightness);
-                t.setColorRGBA_F(colR, colG, colB, rainbowAlpha);
+                int color = HSBtoRGB(i / (float) iterations, 1, (float) (0.3f * this.rainbowBrightness));
+                float rainbowAlpha = (float) ((0.35f - (0.15f * Math.abs(i - iterations / 2) / (iterations / 2f))) * this.rainbowBrightness);
+                t.setColorRGBA_F(Color.redFromInt(color) / 255f, Color.greenFromInt(color) / 255f, Color.blueFromInt(color) / 255f, rainbowAlpha);
                 t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
                 t.addVertexWithUV(size, -100D, size, 0.0D, 1.0D);
                 t.addVertexWithUV(size, -100D, -size, 0.0D, 0.0D);
@@ -936,14 +938,12 @@ public class RenderGlobal
             }
             t.draw();
         } else {
-            rainbowBrightness = 0;
-            rainbowBrightnessDelta = 0;
-            targetRainbowBrightness = 0;
+            this.rainbowBrightness = 0;
         }
 
         // Render moon
         size = 20F;
-        textureManager.loadTexture("/assets/minecraft/textures/terrain/moon.png").bind();
+        this.textureManager.loadTexture("/assets/minecraft/textures/terrain/moon.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
@@ -952,11 +952,11 @@ public class RenderGlobal
         t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
         t.draw();
 
-        float f17 = world.getStarBrightness(partialTick) * sunAlpha;
+        float f17 = this.world.getStarBrightness(partialTick) * sunAlpha;
         if (f17 > 0.0F) {
-            textureManager.loadTexture("/assets/minecraft/textures/colormap/stars/default.png").bind();
+            this.textureManager.loadTexture("/assets/minecraft/textures/colormap/stars/default.png").bind();
             GL11.glColor4f(f17, f17, f17, f17);
-            GL11.glCallList(starList);
+            GL11.glCallList(this.starList);
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glDisable(GL11.GL_TEXTURE_2D);
@@ -974,36 +974,36 @@ public class RenderGlobal
     }
 
     private float getCloudHeightModifier() {
-        return mc.gameSettings.cloudHeight.value * 128;
+        return this.mc.gameSettings.cloudHeight.value * 128;
     }
 
     public void renderClouds(float partialTick) {
-        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType());
         if (!worldTypeFX.hasClouds()) {
             return;
         }
-        if (mc.currentScreen instanceof ScreenPhotoMode) {
+        if (this.mc.currentScreen instanceof ScreenPhotoMode) {
             return;
         }
-        if (mc.gameSettings.fancyGraphics.value == 1) {
+        if (this.mc.gameSettings.fancyGraphics.value == 1) {
             renderCloudsFancy(partialTick);
             return;
         }
         GL11.glDisable(GL11.GL_CULL_FACE);
-        float cameraY = (float) mc.activeCamera.getY(partialTick);
+        float cameraY = (float) this.mc.activeCamera.getY(partialTick);
         byte cloudRadius = 32;
         int i = 256 / cloudRadius;
         Tessellator tessellator = Tessellator.instance;
-        textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
+        this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        Vec3 dimensionColor = world.getDimensionColor(mc.activeCamera, partialTick);
-        float r = (float) dimensionColor.x;
-        float g = (float) dimensionColor.y;
-        float b = (float) dimensionColor.z;
+        Vector3fc dimensionColor = this.world.getDimensionColor(this.mc.activeCamera, partialTick);
+        float r = dimensionColor.x();
+        float g = dimensionColor.y();
+        float b = dimensionColor.z();
         float f6 = 1f / 2048f;
-        double posX = mc.activeCamera.getX(partialTick) + (double) ((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F);
-        double posZ = mc.activeCamera.getZ(partialTick) + (double) ((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F);
+        double posX = this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F);
+        double posZ = this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F);
         int j = MathHelper.floor(posX / 2048D);
         int k = MathHelper.floor(posZ / 2048D);
         posX -= j * 2048;
@@ -1030,10 +1030,10 @@ public class RenderGlobal
     }
 
     public void renderCloudsFancy(float partialTick) {
-        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
-        mc.renderer.beginRenderClouds(partialTick);
+        WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType());
+        this.mc.renderer.beginRenderClouds(partialTick);
 
-        float celestialAngle = world.getCelestialAngle(partialTick);
+        float celestialAngle = this.world.getCelestialAngle(partialTick);
         float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
         float rSun = 0.0f, gSun = 0.0f, bSun = 0.0f, aSun = 0.0f;
         if (sunriseColor != null) {
@@ -1043,24 +1043,24 @@ public class RenderGlobal
             aSun = sunriseColor[3] / 2;
         }
 
-        Vec3 dimensionColor = world.getDimensionColor(mc.activeCamera, partialTick);
-        final float rDim = (float) dimensionColor.x;
-        final float gDim = (float) dimensionColor.y;
-        final float bDim = (float) dimensionColor.z;
+        Vector3fc dimensionColor = this.world.getDimensionColor(this.mc.activeCamera, partialTick);
+        final float rDim = dimensionColor.x();
+        final float gDim = dimensionColor.y();
+        final float bDim = dimensionColor.z();
 
         GL11.glDisable(GL11.GL_CULL_FACE);
-        float cameraY = (float) mc.activeCamera.getY(partialTick);
+        float cameraY = (float) this.mc.activeCamera.getY(partialTick);
         Tessellator tessellator = Tessellator.instance;
         float cloudWidth = 12F;
         float cloudThickness = 4F;
-        double dx = (mc.activeCamera.getX(partialTick) + (double) ((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F)) / (double) cloudWidth;
-        double dz = (mc.activeCamera.getZ(partialTick) + (double) ((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) cloudWidth + 0.33D;
+        double dx = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) cloudWidth;
+        double dz = (this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) cloudWidth + 0.33D;
         float dy = (worldTypeFX.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
         int i = MathHelper.floor(dx / 2048D);
         int j = MathHelper.floor(dz / 2048D);
         dx -= i * 2048;
         dz -= j * 2048;
-        textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
+        this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         float f13 = 1F / 256F;
@@ -1160,7 +1160,7 @@ public class RenderGlobal
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_CULL_FACE);
 
-        mc.renderer.endRenderClouds(partialTick);
+        this.mc.renderer.endRenderClouds(partialTick);
     }
 
     private final DirtyChunkRendererSorter dirtyChunkRendererSorter = new DirtyChunkRendererSorter();
@@ -1190,79 +1190,81 @@ public class RenderGlobal
 //        return this.dirtyChunks.size() <= this.cantBuildRenderers.size(); // Return true if no more dirty renderers
 //    }
 
-    private @Nullable ChunkRenderer @NotNull [] toAdd = new ChunkRenderer[MAX_VISIBLE_REBUILDS_PER_FRAME];
-    private @NotNull List<@NotNull ChunkRenderer> nearChunks = new ArrayList<>();
+    private final @Nullable ChunkRenderer @NotNull [] toAdd = new ChunkRenderer[MAX_VISIBLE_REBUILDS_PER_FRAME];
+    private final @NotNull List<@NotNull ChunkRenderer> nearChunks = new ArrayList<>();
+
     public boolean updateDirtyChunks(@NotNull ICamera camera) {
-        dirtyChunkRendererSorter.setActiveCamera(camera);
-        Arrays.fill(toAdd, null);
+        this.dirtyChunkRendererSorter.setActiveCamera(camera);
+        Arrays.fill(this.toAdd, null);
         this.nearChunks.clear();
 
-        final int pendingChunkSize = dirtyChunks.size();
+        final int pendingChunkSize = this.dirtyChunks.size();
 
-        for(int i = 0; i < pendingChunkSize; i++) {
-            final ChunkRenderer renderer = dirtyChunks.get(i);
-            if(renderer.distanceToCameraSquared(camera) > 2048f) {
+        for (int i = 0; i < pendingChunkSize; i++) {
+            final ChunkRenderer renderer = this.dirtyChunks.get(i);
+            if (renderer.distanceToCameraSquared(camera) > 2048f) {
                 int index = 0;
 
-                while (index < MAX_VISIBLE_REBUILDS_PER_FRAME && (toAdd[index] == null || dirtyChunkRendererSorter.compare(toAdd[index], renderer) <= 0)) {
+                while (index < MAX_VISIBLE_REBUILDS_PER_FRAME && (this.toAdd[index] == null || this.dirtyChunkRendererSorter.compare(this.toAdd[index], renderer) <= 0)) {
                     index++;
                 }
 
-                if(--index <= 0) {
+                if (--index <= 0) {
                     continue;
                 }
 
-                for(int x = index; --x != 0;) {
-                    toAdd[x - 1] = toAdd[x];
+                for (int x = index; --x != 0; ) {
+                    this.toAdd[x - 1] = this.toAdd[x];
                 }
 
-                toAdd[index] = renderer;
+                this.toAdd[index] = renderer;
                 continue;
             }
 
-            nearChunks.add(renderer);
+            this.nearChunks.add(renderer);
         }
 
-        if(!nearChunks.isEmpty()) {
-            if(nearChunks.size() > 1) {
-                nearChunks.sort(dirtyChunkRendererSorter);
+        if (!this.nearChunks.isEmpty()) {
+            if (this.nearChunks.size() > 1) {
+                this.nearChunks.sort(this.dirtyChunkRendererSorter);
             }
-            for (ChunkRenderer renderer : nearChunks){
+            for (ChunkRenderer renderer : this.nearChunks) {
                 if (renderer.rebuild(true)) {
                     renderer.dirty = false;
-                    dirtyChunks.remove(renderer);
+                    this.dirtyChunks.remove(renderer);
                 }
             }
         }
 
-        for(int i = MAX_VISIBLE_REBUILDS_PER_FRAME - 1; i >= 0; i--) {
-            ChunkRenderer chunkx = toAdd[i];
-            if(chunkx == null) { continue; }
-            if(!chunkx.visible && i != MAX_VISIBLE_REBUILDS_PER_FRAME - 1) {
-                toAdd[i] = null;
+        for (int i = MAX_VISIBLE_REBUILDS_PER_FRAME - 1; i >= 0; i--) {
+            ChunkRenderer chunkx = this.toAdd[i];
+            if (chunkx == null) {
+                continue;
+            }
+            if (!chunkx.visible && i != MAX_VISIBLE_REBUILDS_PER_FRAME - 1) {
+                this.toAdd[i] = null;
                 break;
             }
             if (chunkx.rebuild(false)) {
                 chunkx.dirty = false;
-                dirtyChunks.remove(chunkx);
+                this.dirtyChunks.remove(chunkx);
             }
         }
-        return dirtyChunks.isEmpty();
+        return this.dirtyChunks.isEmpty();
     }
 
-    public void drawBlockBreaking(@NotNull ICamera camera, @NotNull HitResult.Tile tileHit, float partialTick)
-    {
+    public void drawBlockBreaking(@NotNull ICamera camera, @NotNull HitResult.Tile tileHit, float partialTick) {
         Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glBlendFunc(770, 1);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float) System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
-        if (destroyProgress > 0.0F) {
+        if (this.destroyProgress > 0.0F) {
             GL11.glBlendFunc(774, 768);
             TextureRegistry.blockAtlas.bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
             GL11.glPushMatrix();
-            int k = world.getBlockId(tileHit.tilePos.x, tileHit.tilePos.y, tileHit.tilePos.z);
+            int k = this.world.getBlockId(tileHit.tilePos);
             Block<?> block = k <= 0 ? null : Blocks.blocksList[k];
             GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(-3F, -3F);
@@ -1285,11 +1287,9 @@ public class RenderGlobal
                 .getDispatch(block)
                 .renderWithOverrideTexture(
                     tessellator,
-                    world,
-                    tileHit.tilePos.x,
-                    tileHit.tilePos.y,
-                    tileHit.tilePos.z,
-                    breakingAnimation[MathHelper.clamp((int)(destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
+                    this.world,
+                    tileHit.tilePos,
+                    breakingAnimation[MathHelper.clamp((int) (this.destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             GL11.glDisable(GL11.GL_ALPHA_TEST);
@@ -1304,10 +1304,10 @@ public class RenderGlobal
     }
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick) {
-        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ScreenModelViewer)) {
+        if (this.mc.gameSettings.immersiveMode.drawOutline() && this.mc.gameSettings.blockOutlineWidth.value > 0.01f && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            float w = mc.getOutlineWidth();
+            float w = this.mc.getOutlineWidth();
             GL11.glColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
             GL11.glLineWidth(java.lang.Math.max(4.0f * w * 2.0f, 1.0f));
             GL11.glDisable(GL11.GL_TEXTURE_2D);
